/*==============================================   
      file : generate.c
 
   purpose : new population generation

 developed : 1991
 
    author : Kalyanmoy Deb
================================================*/

#include "mga.ext"
#include <stdio.h>


long change_popsize()
/*  find out popsize  */
{
	long size;

	size = popsize;
	if ((gen >= init_select_gen) && (gen <= cutpop_gen))
	{
		if ((gen == cutpop_gen) && (size > juxtpopsize))
			size = juxtpopsize;
		else if (gen <= cut_every_other_gen)
		/* cut at every other generation */
		{
			if (cutpopflag == 1)
			{
				size = popsize / 2;
				cutpopflag = 0;
			}
			else 
				cutpopflag = 1;
		}
		else  /* cut at every generation */
			size = popsize / 2;
	}
	return(size);
}


void primordial()
/*  primordial phase  */
{
	int pos,count;
	char msg[PAGEWIDTH];
	long newpopsize;

	TRACE("   Primordial entered");

	/*  check whether population size needs to be changed   */
	newpopsize = change_popsize();
	/* shuffle the population */
	pick = 0;
	shuffle_pop();
	count = 0;
	/*  create a new population  */
	while (count < newpopsize) {
		/*  select an individual  */
		pos = select_pop();

		/* copy it in the new population  */
		copy_chrom(oldpop[pos],&(newpop[count]));

		count++;
	}
	popsize = newpopsize;
	reallocate_memory(popsize);

	TRACE("   Primordial exited\n");
}


void juxtapositional()
/*  juxtapositional phase  */
{
	int pos1, pos2, count, marker;
	register int i;
	struct INDIVIDUAL mate1, mate2;
	double prf;
/*	double pfitns;      */

	TRACE("   Juxtapositional entered");
	
	/* shuffle the population */
	pick = 0;
	shuffle_pop();
	count = 1;
	/* free memory allocated for new population */
/*	TRACE(" BEF FREENEWPOP\n");
	getchar();  */
	freenewpop();
/*	TRACE(" AFT FREENEWPOP\n");
	getchar();  */
	/*  create new population */
	do {
		/*  generate mate1 and mate2  */
		storepop(&mate1,1);
		/*  select two individuals for mating  */
		pos1 = select_pop();
		copy_chrom(oldpop[pos1],&mate1);

		storepop(&mate2,1);
		pos2 = select_pop();
		copy_chrom(oldpop[pos2],&mate2);


/*		pfitns = oldpop[pos1].fitness;
		if(pfitns < oldpop[pos2].fitness)
			pfitns = oldpop[pos2].fitness;      */
		/* cut and splice two individuals */
		cut_and_splice(mate1,mate2);
		stack_pos = 1;
		sort_stack();
		
		marker = 1;
		/* put children individuals in new population  */
		while (count <= popsize && ! isempty(newchrom_stack)) {
			if (pop_stack(&newchrom_stack,&(newpop[count])))
			{
				/*  perform mutation  */
			/*	mutation(&(newpop[count]));  */

				/*  find out raw chrom  */
/*				if(gen != prim_gen +1)
				prf = fill_chrom(&(newpop[count]));
				prf /= newpop[count].chromlen;  */
				/*  evaluate objective function value  */
/*		if(gen != prim_gen +1)
		newpop[count].fitness = objfunc(newpop[count].fullchrom);  */
/*		writefullchrom(stdout,newpop[count].fullchrom);
		fprintf(stdout, " fitness=%f \n", newpop[count].fitness);
		getchar();
		getchar();  */
/*		fprintf(stdout, " prf=%lf  ",prf);
		getchar(); getchar();  */
/*				newpop[count].Pfitness = pfitns;     */
			if(shuffle_stack[count] == marker)
				count++;  
			marker++;
/*	fprintf(sf,"%lf    ",newpop[count].fitness);  */
	
			}
		}
	}    while (count <= popsize);

	TRACE("   Juxtapositional exited\n");
}

int repeatation(S, n)
int S[7], n;
{
	int i;
	for(i=0; i<n; i++)  {
		if(S[i] == S[n]) {
			return 0;
		}
	}
	return 1;
}
		
void update_priority()
{
	int i, j, k, Gpos[7];
	unsigned temp_allele, shield, tempmask_gene, tempmask = 1;
	struct GENE *temp;
	struct GENE *tem;
	struct GENE exprs[300];
	struct GENE unexprs[300];
	int h1, h2, id, rem, temp_gene, k1, pickYes; 
	int gcount = 0;
	int count = 0;
        unsigned *rawchr, *tmpchr;


		temp = newpop[i].firstgene;
	rawchr = (unsigned *)malloc(bytesize*sizeof(unsigned));
	tmpchr = (unsigned *)malloc(bytesize*sizeof(unsigned));
  for(i=0; i< popsize; i++) {
      if(gen == prim_gen) {
		gcount = 0;
		h1 = 0;
		h2 = 0;
/*		writefullchrom(stdout,newpop[i].fullchrom);
		fprintf(stdout, "\n\n");
		fprintf(stdout," Chromlen=%d  ",newpop[i].chromlen);
		fwritechrom(stdout,newpop[i],32);
		fprintf(stdout, "\n\n");
		getchar();
		getchar();
	*/
                for (j = 0; j < bytesize; j++)
                        tmpchr[j] = template[j];
		temp = newpop[i].firstgene;
                for(j=0; j<6; j++) {
			while(1){
                        Gpos[j] = rnd(0,ldash-1);
			if(repeatation(Gpos,j)) break;
			}
		}
	while (temp != NIL) {
                temp_allele = temp->allele;
                temp_gene = temp->genenumber;
                id = temp_gene/UNSINTSIZE;
                rem = temp_gene % UNSINTSIZE;
                shield = tempmask << rem;
               /* if (((tmpchr[id] >> rem) & tempmask) != temp_allele) 
                        temp->priority += 1;   
		if (newpop[i].fitness <= 210.0)
                        temp->priority += 1;    */

		for(k1=0; k1<6; k1++) {
                if(gcount == Gpos[k1]){
                        pickYes = 1;
			break;
		}
                else pickYes = 0;
                }
        /*        pickYes = 0;  */
                if(pickYes == 0) {
                        exprs[h1].genenumber = temp->genenumber;
                        exprs[h1].allele = temp->allele;
                if (((tmpchr[id] >> rem) & tempmask) != temp_allele) 
                        temp->priority += 0;   
                        exprs[h1].priority = temp->priority;
                        h1++;

                }
                else {
                        unexprs[h2].genenumber = temp->genenumber;
                        unexprs[h2].allele = temp->allele;
                        unexprs[h2].priority = temp->priority;
                        h2++;
                }

		temp = temp->nextgene;
		gcount++;
	}
       }   
  else  if(gen > prim_gen + 0) {  
		h1 = 0;
		h2 = 0;
	/*	writefullchrom(stdout,newpop[i].fullchrom);
		fprintf(stdout, "\n\n");
		fprintf(stdout," Chromlen=%d  ",newpop[i].chromlen);
		fwritechrom(stdout,newpop[i],32);
		fprintf(stdout, "\n\n\n\n");
		getchar();
	*/
		temp = newpop[i].firstgene;
        	for (j = 0; j < bytesize; j++)
               	 	rawchr[j] = newpop[i].fullchrom[j];
                for (j = 0; j < bytesize; j++)
                        tmpchr[j] = template[j];


	   while (temp != NIL) {
		temp_allele = temp->allele;
		temp_gene = temp->genenumber;
		id = temp_gene/UNSINTSIZE;
                rem = temp_gene % UNSINTSIZE;
                shield = tempmask << rem;

		if(newpop[i].fitness < templatefitness) {  
		  if (((tmpchr[id] >> rem) & tempmask) != temp_allele)  {
			temp->priority += 0;  
			exprs[h1].genenumber = temp->genenumber;
			exprs[h1].allele = temp->allele;
			exprs[h1].priority = temp->priority;
			h1++;
		  }
		  else {
			temp->priority -= 0;	
			unexprs[h2].genenumber = temp->genenumber;
                        unexprs[h2].allele = temp->allele;
                        unexprs[h2].priority = temp->priority;
			h2++;
                  }
		}
		else {
		  if (((rawchr[id] >> rem) & tempmask) != temp_allele) {    
                        temp->priority -= 0;   
			exprs[h1].genenumber = temp->genenumber;
                        exprs[h1].allele = temp->allele;
                        exprs[h1].priority = temp->priority;
			h1++;
		  }
                  else {
/*		if (((tmpchr[id] >> rem) & tempmask) == temp_allele)  */
			temp->priority += 0;       
			unexprs[h2].genenumber = temp->genenumber;
                        unexprs[h2].allele = temp->allele;
                        unexprs[h2].priority = temp->priority;
			h2++;
                  }
                }
		temp = temp->nextgene;
	   }
	 }
	if(gen == prim_gen ) {	
		tem = newpop[i].firstgene;
		for(k=0; k<h2; k++) {
			tem->genenumber = unexprs[k].genenumber;
			tem->allele = unexprs[k].allele;
			tem->priority = unexprs[k].priority;
			if(k<h2-1 || h1 != 0)
			tem = tem->nextgene;
		}
		for(k=0; k<h1; k++) {
			tem->genenumber = exprs[k].genenumber;
			tem->allele = exprs[k].allele;
			tem->priority = exprs[k].priority;
			if(k<h1-1)  
			tem = tem->nextgene;
		}
		newpop[i].chromlen = h1 + h2;
		newpop[i].lastgene = tem;
		tem = tem->nextgene;
		tem = NIL;    
/*	fprintf(stdout," GENE %d  ", newpop[i].lastgene->genenumber);
	fprintf(stdout,"ALLELE %d  ", newpop[i].lastgene->allele);
	fprintf(stdout,"PRIORITY %d  ", newpop[i].lastgene->priority);
	fprintf(stdout," h1= %d h2=%d  CHROMLEN %d  ",h1,h2,newpop[i].chromlen);
	fprintf(stdout," FITNESS=%f  ",newpop[i].fitness);
	fprintf(stdout, "\n\n");  
	fwritechrom(stdout,newpop[i],32);
	fprintf(stdout, "\n\n");
	getchar();  */
/*		fprintf(stdout, "\n\n");
		fwritechrom(stdout,newpop[i],32);
		fprintf(stdout, "\n\n");  */
        }
   }
}


void generate()
/*   messy GA operation   */
{
	struct INDIVIDUAL *tempop;

	printf("\nera = %d, generation = %d\n\n",era,gen);
	TRACE("Generate entered");
        
	phaseF = 1;

	if (gen <= prim_gen)  {
		primordial();
	/*	if(gen == prim_gen) {
		popsize = juxtpopsize;
		reallocate_memory(popsize);    
		}    */
	}
	else {
		phaseF = 0;
		juxtapositional();  }

/* 	statistics(newpop);   */
	if(gen >= prim_gen)
	update_priority();     
	statistics(newpop);
	reportpop(newpop);

 	/* copy newpop to oldpop */
	tempop = oldpop;
	oldpop = newpop;
	newpop = tempop;

	TRACE("Generate exited");
}

